var infotext = `
    <style>
        .tab {
            overflow: hidden;
            border: 1px solid #ccc;
            background-color: #f1f1f1;
        }
        
        .tab button {
            background-color: inherit;
            float: left;
            border: none;
            outline: none;
            cursor: pointer;
            padding: 14px 16px;
            transition: 0.3s;
        }
        
        .tab button:hover {
            background-color: #ddd;
        }
        
        .tab button.active {
            background-color: #ccc;
        }
        
        .tabcontent {
            display: none;
            padding: 6px 12px;
            border: 1px solid #ccc;
            border-top: none;
            animation: fadeEffect 1s; /* Fading effect takes 1 second */
        }
          
        /* Go from zero to full opacity */
        @keyframes fadeEffect {
        from {opacity: 0;}
        to {opacity: 1;}
        }    </style>    

    <!-- Tab links -->
    <div class="tab">
      <button class="tablinks" id="defaultOpen" onclick="openTab(event, 'News')">News</button>
      <button class="tablinks" onclick="openTab(event, 'Idee')">Idee</button>
      <button class="tablinks" onclick="openTab(event, 'ToDo')">ToDo</button>
      <button class="tablinks" onclick="openTab(event, 'Kontakt')">Kontakt</button>
    </div>
    
    <!-- Tab content -->
    <div id="News" class="tabcontent">
    <div style="margin: 20px 0px;">Vielen Dank für die zahlreichen Ideen und Anregungen. Ich versuche diese zeitnah umzusetzen, was nicht immer
    ganz einfach ist. Die aktuelle Entwicklung können Sie hier verfolgen.</div>
    <h3>19.11.2019</h4>
    <ul>
      <li>Wurde ein Projekte über den Menüeintrag "Lokal öffnen" importiert oder ein Projekt über "Lokal speichern unter" gesichert, so merkt sich 
	  das System den Dateinamen. Änderungen können dann mittels STRG+S oder über den Menüpunkt "Sichern" automatisch in die entsprechende 
	  Projektdatei übernommen werden. Der Name der aktuell geladenen Projektdatei findet sich im Reiter.
	  </li>
      <li>Importiert man Projekte über den Menüeintrag "Lokal öffnen", wird die automatische Generierung der GUI deaktiviert. Man 
	  kann diese Einstellung über die Rubrik "Ansicht" jederzeit wieder aktivieren.</li>
      <li>In manchen Fällen verschiebt sich das Ein- / Ausgabefester so weit nach oben, dass es der Titel nicht mehr sichtbar ist. 
	  Damit lässt sich das Fenster auch nicht mehr verschieben. Das Fenster kann nun durch das Aus- und wieder Einblenden (STRG+E) wieder nach unten
	  in den sichtbaren Bereich verschieben werden.</li>
    </ul>
    <h3>15.10.2019</h4>
    <ul>
      <li>Über den Eintrag "Publizieren" in der Rubrik "Datei" oder per Tastaturkürzel STRG+ENTER kann die Seite nun im Web 
      publiziert werden. Der resultierende Link ist im Infobereich sichtbar. Dieser Link ist bis Mitternacht des gleichen Tages gültig.
      Direkt nach 0 Uhr wird die Seite auf dem Webserver gelöscht. Die Schüler
      können die Seite damit auf jedem internetfähigen Endgeräte betrachten, auch auf einem Smartphone. Dies macht vor allem dann Sinn,
      wenn spezielle Hardware angesprochen wird, die vor allem auf mobilen Endgeräten vorhanden ist (Lagesensor, Ortsdaten, ...).
      <u>Anmerkung:</u> In der Regel ändert sich der Link für den aktuellen Tag nicht, solange man auf dem gleichen Rechner entwickelt. Damit kann die Seite nach Änderungen mehrfach publiziert
      werden, ohne dass der Link erneut auf dem Smartphone eingegeben werden muss. Es reicht dort dann ein Neuladen der Seite. Nachteilig
      dabei ist, dass die Schüler keine Seiten parallel publizieren können. Das Verhalten ist gewünscht, um die Ressourcen auf dem
      Zielrechner zu schonen.</li>
    </ul>
    <h3>14.10.2019</h4>
    <ul>
      <li>Das Dokument "Interaktion mit dem Anwender", welches über die Rubrik "Hilfe" abrufbar ist, wurde um Informationen zur
        Gestaltung einer benutzerdefinierten GUI erweitert.</li>
      <li>Neben dem Javascipt-Code kann nun auch der Code zur Darstellung einer GUI über Thommy erzeugt werden. Dazu befinden sich
        über dem Editorfenster zwei Reiter, mit welchem man zwischen dem Javascript-Code (Code) und dem HTML-Code (GUI)wechseln kann. Beachten Sie, 
        dass die Einstellung zur automatischen Generierung der GUI deaktiviert ist. Ansonsten wird bei jeder Programmänderung die GUI automatisiert neu
        erstellt, Ihre Anpassungen gehen damit verloren.</li>
      <li>Die automatische Generierung einer GUI ist nun standardmäßig deaktiviert. Möchte man die GUI vom System erstellen lassen,
        dann ist in der Rubrik "Ansicht" der Eintrag "Gui autom. generieren" zu aktivieren. Tipp: Der generierte Code kann im Reiter "GUI"
        eingesehen und verändert werden.</li>
      <li>Zu jeder Aufgaben in den Kursen kann nun eine GUI-Vorlage bereitgestellt werden.</li>
    </ul>
    <h3>10.09.2019</h4>
    <ul>
      <li>Sie können nun sehr einfach auf Ihrer eigenen HTML-Seite einen Thommy-Knopf integrieren. Ein Klick auf diesen Knopf öffnet die Thommy-IDE
      in einem neuen Browsertab und übernimmt dabei den Programmcode aus Ihrer Seite.  Sie profitieren nun von allen Funktionen der Thommy-IDE,
      beispielsweise können Sie das Struktogramm betrachten, den Code im Debug-Modus ausführen oder einfach nur ein PDF-Dokument mit
      dem Programmcode und dem zugehörigen Struktogramm zur Ergebnissicherung erzeugen lassen. Eine kurze Anleitung "Thommy-Integration"
      finden Sie im Menü "Hilfe".</li>
    </ul>
    <h3>09.09.2019</h4>
    <ul>
      <li>Im Menü "Hilfe" findet sich ein Dokument, welches die Interaktionsmöglichkeiten mit dem Anwender beschreibt. Neben der Möglichkeit 
      der Erzeugung von Ein- / Ausgabefeldern wird auch die Verwendung von Schaltflächen für den Aufruf von Funktionen beschrieben. Hilfreiche
      Beispiele finden sich auch im Kurs "Thommy-Einführung"!</li>
      <li>Das Menü "Hilfe" wurde um einen weiteren Democode zur Überprüfung einer Zahl auf Primzahl ergänzt.</li>
    </ul>
    <h3>07.09.2019</h4>
    <ul>
      <li>Der Kurs "Aufgabensammlung BG JGS1 (BW)" wurde komplettiert. Dort finden sich nun alle Aufgaben, Informationsblätter und Vorlagen,
      die auch in den offiziellen Unterlagen des neuen Bildungsplans vorhanden sind.</li>
    </ul>
    <h3>04.09.2019</h4>
    <ul>
      <li>Im Struktogramm werden zusätzliche, für die SchülerInnen hoffentlich hilfreiche Informationen eingeblendet. Diese Texte
      können über den Menüeinrtag "Ansicht->Zusatzinfo im Struktogramm" ein- und ausgeblendet werden.</li>
      <li>Über "Datei->Laden" oder mittels der Tastenkombination ALT+O kann der zuvor gespeicherte Programmcode wieder hergestellt
      werden.</li>
    </ul>
    <h3>03.09.2019</h4>
    <ul>
      <li>Die Thommy-IDE kann nun automatisch Schalflächen (Buttons) erstellen und diese mit einer Funktion verknüpfen. Bei Klick auf eine
      solche Schaltfläche wird die zugeordnete Funktion aufgerufen. Die Schaltflächen werden im Ein- / Ausgabefenster dargestellt.
      Informationen zur Erzeugung und Verwendung solcher Schaltflächen finden Sie im Kurs "Thommy-Einführung" im Abschnitt 7!</li>
      <li>Erweiterung und kleine Korrekturen des Kurses "Thommy-Einführung". </li>
      <li>Nach Klick auf den Menüeintrag 'Datei -> HTML-Vorlage erzeugen' wird der Javascript-Code in eine HTML-Datei eingebettet, die dann an den Browser
      ausgeliefert wird. Neben dem Javascript-Code werden in die HTML-Seite auch die automatisch generierten Ein- und/oder Ausgabefelder 
      und eine zusätzliche Schaltfläche für das Starten des Programms übernommen. Dies ermöglicht die Weiterverarbeitung des
      erstellten Javascript-Codes in einem normalen Editor, also auch ohne die Thommy-IDE. Neben der Modifizierung des Javascript-Codes
      können die Schüler die Seite auch um zusätzliche HTML-Elemente oder CSS-Regeln erweitern. Damit lassen sich unter anderem die 
      Lerninhalte der Eingangsklasse wiederholen (HTML + CSS).<br>
      <i>Möglicherweise könnte so auch das Ergebnis einer Klassenarbeit eingesammelt werden.</i></li>
      <li>Javascript-Dateien können nun direkt im Dateisystem auf dem lokalen Rechner oder auf einem Netzlaufwerk gespeichert werden. Ebenso ist ein
      Laden der Dateien aus dem Dateisystem möglich. LehrerInnen können somit sehr einfach Vorlagen für die SchülerInnen bereitstellen. Diese Funktion nutzt eine
      sehr neue, noch experimentelle API, die aktuell nur von Google Chrome unterstützt wird. Die API muss zunächst aktiviert werden.
      Besuchen Sie die Seite 'chrome://flags/#native-file-system-api' in einem neuen Google Chrome-Tab und aktivieren Sie den Dateizugriff
      (Native File System API). Nach erfolgreicher Aktivierung und einem Neustart des Browsers erscheinen in der Rubrik 'Datei' weitere Menüeinträge.<br><i>Siehe auch <a href="https://wicg.github.io/native-file-system/" target="_extern">https://wicg.github.io/native-file-system</a> und <a href="https://t3n.de/news/native-file-system-api-fuer-1191965/" target="_extern">https://t3n.de/news/native-file-system-api-fuer-1191965/</a></i></li>
    </ul>
    <h3>23.08.2019</h4>
    <ul>
      <li>Der Infobereich lässt sich nun auch über einen  Splitter dynamisch in der Höhe anpassen.</li>
      <li>Die Inhaltsbereiche im Informationsbereich werden bei neuen Nachrichten immer ans Ende gescrollt, so dass die Nachricht
      auf jeden Fall im sichtbaren Bereich zu finden ist.</li>
    </ul>
    <h3>22.08.2019</h4>
    <ul>
      <li>Unter "Hilfe->Tastaturkürzel" ist eine Liste mit den Tastaturkürzeln abrufbar.</li>
      <li>In der Rubrik "Hilfe" sind hilfreiche Links hinterlegt.</li>
      <li>Mittels Snackbar wird über verschiedene Ereignisse informiert (Speichern, PDF-Export, ...)</li>
    </ul>
    <h3>19.08.2019</h4>
    <ul>
      <li>Es wurde ein weiterer Kurs "Thommy-Einführung" hinzugefügt, welcher die zentralen Funktionen
      der IDE vorstellt.</li>
      <li>Im PDF-Export werden nur die Komponenten (Programmcode, Struktogramm) übernommen, die aktuell auch
      sichtbar sind.</li>
    </ul>
    <h4>18.08.2019</h4>
      <ul>
        <li>Über den Menüeintrag "Datei->PDF erzeugen" kann nun eine PDF-Datei mit dem Programmcode und dem
        zugehörigen Struktogramm erzeugt werden. Die SchülerInnen können so auf einfach Weise ihre Ergebnisse 
        dauerhaft sichern. Der Programmcode wird vor dem Ausdruck automatisch gespeichert.</li>
      </ul>
      <h4>17.08.2019</h4>
      <ul>
        <li>Verbesserungen in der Erkennung von Ein-/Ausgabeoperationen. Im Ein-/Ausgabefenster (Altivierung über den 
          Menüeintrag Ansicht) werden nun alle notwendigen Ein- / Ausgabeelement erzeugt. 
        </li>
        <li>Bei der Darstellung der Informationen zu der aktuell ausgewählten Aufgabe (Kurs!) werden nun weitere
          Schaltflächen dargestellt, die einen schnellen Wechsel in den Kurs ermöglichen. Zustätzlich gibt es bereits
          einen Knopf "Prüfen", welcher es den Schülern ermöglichen soll, ihre Lösung selbständig auf Richtigkeit zu prüfen.
          Auch wurden kleine Änderungen in der Darstellung der Informationen vorgenommen.
        </li>
        <li>Kleine Verbesserungen in der Darstellung des Struktogramms. 
        </li>
      </ul>
      <h4>16.08.2019</h4>
      <ul>
        <li>Das Menü wurde um eine Rubrik "Kurse" erweitert. Die SchülerInnen können hier einen Kurs auswählen. Die
        zugehörigen Aufgaben werden in einem modalen Fenster aufgelistet und können dort von den SchülerInnen ausgewählt
        werden. Zu jeder Aufgabe stehen optional weitere Dokumente und eine Vorlagen zur Verfügung. Nach Auswahl einer
        Aufgabe erscheint im Informationsbereich ein weiterer Reiter "Aktuelle Aufgabe" mit der Aufgabenstellung. Dieser
        kann bei Bedarf geschlossen werden.<br>
        Aktuell findet sich im System ein Kurs mit den Aufgaben zur LPE 2 des neuen BPs im Fach Informatik. Die Aufgaben
        werden in Kürze vervollständigt.</li>
        <li>Bevor ein neuer Programmcode in den Editor geladen wird, erfolgt eine Nachfrage, ob man den bestehenden Programmcode
        überschreiben möchte.</li>
        <li>Der Programmcode kann über den Menüenitrag 'Datei->Speichern' auf dem lokalen Rechner gespeichert werden.
        Beim Neustart der Thommy-IDE mit dem gleichen Browser wird der zuletzt gespeicherte Programmcode automatisch geladen. Eine automatische
        Speicherung des Programmcodes erfolgt jeweils vor einer Programmausführung. Informationen zum Speichervorgang finden
        sich im Reiter "Info" im Informationsbereich.<br>
        Achtung: Die Speicherung erfolgt lediglich im Browser-Profil des Benutzers auf dem lokalen Rechner. Je nach
        Browserinstallation kann dieses Profil auf dem lokalen Rechner oder zentral im 'Windows-Profil' des Schülers auf
        dem Schulserver liegen. Im zweiten Fall wird der Programmcode des Schülers auch dann geladen, wenn er sich
        an einem anderen Rechner innerhalb des Schulnetzes anmeldet.</li>
        <li>Ausgaben der Aufrufe der Javascript-Funktionen 'document.write(...)', document.writeln(...)' und 'console.log(...)' werden
        in einem neuen Reiter 'Konsole' im Informationsbereich angezeigt. Dies entspricht nicht dem Standardverhalten
        dieser Funktionen, verhindert aber, dass der Aufruf der
        'write'-Funktionen den Inhalt des Browserfensters ersetzt und die Thommy-IDE verschwindet. Auch müssen die 
        SchülerInnen nicht die Entwicklerkonsole öffnen, um die Ausgaben, die mittels "console.log(...)' erfolgen, sehen
        zu können.
        Möglicherweise kann diese mit den SchülernInnen kurz erörtert werden. 
        </li>
        <li>Treten bei der Ausführung oder beim Debuggen des Programms Fehler auf, dann wird die Beschriftung des 
        Reiters "Fehler" im Infobereich in "Fehler!!!" geändert. Auch bei nicht aktiviertem Reiter "Fehler" kann
        damit erkannt werden, ob bei der Ausführung Fehler aufgetreten sind.</li>
      </ul>
      <h4>15.08.2019</h4>
      <ul>
        <li>Layout: Integration eines zusätzlichen Panels mit einigen Reitern am unteren Fensterrand. 
        Hier werden nun Fehlermeldungen und weitere Informationen angezeigt.</li>
        <li>Layout: Kleine Verbesserungen im Layout (bessere Nutzung des zur Verfügung stehende Platzes).</li>
        <li>Alle Overlay-Fenster können nun per Maus geschlossen werden. Passiert dies beim Debug-Informationsfenster,
        dann wird der Debug-Vorgang abgebrochen.</li>
      </ul>
      <h4>14.08.2019</h4>
      <ul>
        <li>Layout: Während des Ladens wird ein Splash-Screen angezeigt</li>
        <li>Layout: Alle Aktionen sind nun in einem Menu untergebracht</li>
        <li>Layout: Zentrale Funktionen können mittels Shortcut ausgeführt werden</li>
        <li>Layout: Die Bereiche für den Programmcode und das Struktogramm können nun separat ein- und ausgeblendet werden (Menü &quot;Ansicht&quot;).</li>
        <li>Layout: Die Breiten der Bereiche für den Programmcode und das Struktogramm können nun mittels Slider individuell eingestellt werden.</li>
        <li>Layout: Das Fenster zur Anzeige der Ein- und Ausgabefelder ist nun als Overlay realisiert. Standardmäßig ist dieses nicht 
          sichtbar. Die Sichtbarkeit  kann über das Menü &quot;Ansicht&quot; gesteuert werden. Position und Größe des
          Fensters sind änderbar.</li>
        <li>Layout: Das Fenster zur Anzeige der Debug-Informationen ist nun als Overlay realisiert. Es wird automatisch
            eingeblendet, wenn das Programm im Debug-Modus ausgeführt wird. Position und Größe des
            Fensters sind änderbar.</li>
        <li>Layout: Im Debug-Informationsfenster sind mehrzeilige Ausgabefelder nun in der Größe veränderbar.</li>
      </ul>
      <h4>16.06.2019</h4>
      <ul>
        <li>Einbau eines Debuggers: Der Programmcode kann nun schrittweise ausgeführt werden. Der ausgeführte 
        Programmteil wird dabei sowohl im Editor, als auch im Struktogramm markiert. Die aktuellen Werte der
        im Programm eingesetzten Variablen werden angezeigt, ebenso der Funktionen-Stack und de Ausgabe in 
        die Konsole.
        </li>
        <li>Erstellung dieser Info-Seite</li>
        <li>Schaltfläche "Demo-Code": diese ermöglicht das Laden eines kleinen Programms. Somit können die 
        Funktionen der Anwendung bequem getestet werden.</li>
      </ul>
      <h4>15.06.2019</h4>
      <ul>
        <li>Kompletter Umbau des Parse-Prozesses. Es werden nun deutlich mehr Sprachkonstrukte korrekt erkannt.</li>
        <li> Ein Klick auf einen Block im Struktogramm markiert den zugehörigen Programmcode im Editor</li>
      </ul>
      <h4>11.06.2019</h4>
      <ul>
        <li>Neue Editor-Funktionen: Syntaxhighlightning, Syntaxvalidierung, Autovervollständigung (STRG+LEER),
        Suchfunktion (STRG+F), Suche+Ersetzen (STRG+H), Zurückfunktion (STRG-Z), Foldable, Einrückhilfe, 
        Zeilennummern, ...
        </li>
      </ul>
      <h4>27.05.2019</h4>
      <ul>
        <li>
            Beautifier: Formatierung des Programmcodes bei Klick auf die Schaltfläche "Beautfier"
        </li>
      </ul>
    </div>

    
    <div id="Idee" class="tabcontent">
      <h3>Idee</h3>
      <p>
        Das Hauptziel der Anwendung ist die Unterstützung der LehrerInnen und der SchülerInnen bei der Erlernung
        der Grundlagen der strukturierten Programmierung. Die Umsetzung als Online-Plattform ermöglicht die
        Benutzung ohne weitere Vorarbeiten oder Installationen, ein aktueller Browser ist ausreichend.
        Der Fokus kann direkt auf die eigentlichen 
        Lerninhalte gelegt werden. Die SchülerInnen erhalten dabei vom System zahlreiche Hilfestellungen. 
        Beispielsweise kann der Programmcode durch einen einfachen Klick nach allgemeingültigen Regeln
        automatisch formatiert werden. Bereits während der Eingabe des Programmcodes erfolgt eine Syntaxprüfung.
        Die Interaktion von selbst erstellten Programmen mit dem Anwender wird
        durch automatisierte Erzeugung geeigeter Ein- und Ausgabeelementen unterstützt. Weitere Funktionen wie
        die automatische Generierung (live) eines Struktogramms oder die schrittweise Ausführung des 
        Programmcodes helfen, die Strukturen und den Ablauf besser zu verstehen. Im "Debug-Modus" werden die
        aktuell ausgeführten Programmteile sowohl im Editor, als auch im Struktogramm markiert. Aktuelle Inhalte von 
        Variablen und die Reihenfolge der Methodenaufrufe (stack) werden angezeigt.
      </p>
    </div>
    
    <div id="ToDo" class="tabcontent">
      <h3>ToDo</h3>
      <h4>Kurzfristig</h4>
      <ul>
        <li>Der Export der HTL-Vorlage bei Verwendung einer benutzerdefinierten GUI erkennt selbsterstellte Funktionen nicht.</li>
        <li><strike>Erkennungsrate der Sprachkonstrukte erhöhenErkennungsrate der Sprachkonstrukte erhöhen</strike></li>
        <li><strike>Komplette Neugestaltung des Designs</strike></li>
        <li><strike>Bereitstellung einer Anleitung</strike></li>
        <li><strike>Überarbeitung der Darstellung des Struktogramms</strike></li>
      </ul> 
      <h4>Mittelfristig</h4>
      <ul>
        <li>Möglichkeit der Erstellung bzw. Änderung des Stuktogramms, inklusive Aktualisierung des 
        Programmcodes</li>
        <li><strike>Druckfunktion</strike></li>
        <li><strike>Speicherung und erneutes Laden der erstellten Programme</strike></li>
        <li><strike>Bereitstellung von Lernunterlagen / Kursen</strike></li>
      </ul> 
      <h4>Langfristig</h4>
      <ul>
        <li>Automatsiche Validierung der Programmlogik</li>
        <li>Überwachung des Lernfortschritts der Schüler</li>
      </ul> 
    </div>
    
    <div id="Kontakt" class="tabcontent">
      <h3>Kontakt</h3>
      <p>
        Thomas Perschke<br>
        thommy@perschke.info
      </p>
      <div class="stat"></div>
    </div>    
 
`;

function openTab(evt, tabname) {
  // Declare all variables
  var i, tabcontent, tablinks;

  // Get all elements with class="tabcontent" and hide them
  tabcontent = document.getElementsByClassName("tabcontent");
  for (i = 0; i < tabcontent.length; i++) {
    tabcontent[i].style.display = "none";
  }

  // Get all elements with class="tablinks" and remove the class "active"
  tablinks = document.getElementsByClassName("tablinks");
  for (i = 0; i < tablinks.length; i++) {
    tablinks[i].className = tablinks[i].className.replace(" active", "");
  }

  // Show the current tab, and add an "active" class to the button that opened the tab
  document.getElementById(tabname).style.display = "block";
  evt.currentTarget.className += " active";
}
