var tdemoV1 = {
    "id": "tdemoV1",
    "title": "Kurzeinführung in die IDE Thommy",
    "description": `Dieser Kurs führt in die zentralen Konzepte der IDE-Thommy ein. Übernehmen Sie bei der 
                    Bearbeitung einer Aufgabe bitte immer die Programmvorlage, d. h. bejahen Sie die Nachfrage
                    "Wollen Sie den bestehenden Code ersetzen?".`,
    "tasks": [


        {
            "id": "0",
            "pos": 1,
            "lfs": "L1",
            "title": "Hello World",
            "hint": "Keine Hinweise vorhanden",
            "material": [
                {
                    "title": "prompt-Funktion",
                    "url": "https://www.w3schools.com/jsref/met_win_prompt.asp"
                },
                {
                    "title": "alert-Funktion",
                    "url": "https://www.w3schools.com/jsref/met_win_alert.asp"
                }
            ],
            "task": `Wählen Sie diese Aufgabe durch Klick auf "Aufgabe bearbeiten" aus. Lesen Sie die Kommentare 
            in der Programmvorlage (Editor). Starten Sie das Programm. Ändern Sie den Namen der Variablen 
            "meinname" in "meinname2" und beobachten Sie die Änderungen im Struktogramm.`,
            "template": `// Einführung in die Thommy-IDE
// L1: Hello world

//Sie haben eben die erste Aufgabe des Kurses gewählt.
//Die Aufgabenstellung finden Sie auch noch einmal
//im Infobereich am unteren Fensterrand im Reiter
//"Aktuelle Aufgabe (1)".

//Beachten Sie: In der rechten Fensterhälfte wird 
//bereits das zum Programmcode gehörige Struktogramm 
//dargestellt. Das Struktogramm wird 'live' aktualisiert,
//d.h. Änderungen im Programmcode werden automatisch und
//ohne Zeitverzögerung im Struktogramm berücksichtigt.

//Drücken Sie die Tastenkombination STRG+F11 um das
//Programm auszuführen. Alternativ können Sie auch 
//den Menüeintrag "Programm->Ausführen" anwählen.


var meinname = prompt("Geben Sie Ihren Namen ein: ");
alert("Hallo " + meinname);



//Aufgabe erledigt? Dann einfach im Infobereich im Reiter 
//auf die "Aktuelle Aufgabe (1)" auf die Schaltfläche 
//"Kurs anzeigen" klicken und nächste Aufgabe auswählen.


alert("Ende");
`
        },

        {
            "id": "1",
            "pos": 2,
            "lfs": "L2",
            "title": "Eingabe / Ausgabe (alert/prompt) und Debugger",
            "hint": "Keine Hinweise vorhanden",
            "material": [
                {
                    "title": "prompt-Funktion",
                    "url": "https://www.w3schools.com/jsref/met_win_prompt.asp"
                },
                {
                    "title": "alert-Funktion",
                    "url": "https://www.w3schools.com/jsref/met_win_alert.asp"
                },
                {
                    "title": "parseInt-Funktion",
                    "url": "https://www.w3schools.com/jsref/jsref_parseint.asp"
                }
            ],
            "task": `Lesen Sie die Kommentare 
            in der Programmvorlage (Editor) aufmerksam. Starten Sie das Programm.
            <p>Sollten die Ein- und Ausgabedialoge verwirrend
            sein, dann starten Sie das Programm im Debug-Modus. Wählen Sie dazu den Menüeintrag "Programm->Debuggen".
            Es erscheint ein neuer Dialog, in welchem Sie das Programm schrittweise ausführen können. Klicken Sie dazu
            auf die Schaltfläche "Nächster Schritt". Die aktuell ausgeführte Programmanweisung wird sowohl im Editor,
            als auch im Struktogramm markiert. Im Debug-Informationsfenster können Sie auch die aktuelle Belegung der
            Variablen verfolgen!</p>`,
            "template": `// Einführung in die Thommy-IDE
// L2: Eingabe / Ausgabe (alert/prompt)

//Viele Programm interagieren mit dem Anwender. Sowohl 
//für die Eingabe von Daten als auch für die Ausgabe von 
//Daten bestehen zahlreiche Alternativen. 

//Für das Abfragen von Daten vom Anwender steht beispielsweise
//die Funktion "prompt" zur Verfügung. Diese öffnet
//einen modalen Dialog und zeigt die als Parameter übergebene
//Zeichenkette an. Die Benutzereingabe wird von der
//Funktion "prompt" zurückgeliefert und kann beispielsweise
//einer Variablen zugeordnet werden.

var meinname = prompt("Geben Sie Ihren Namen ein: ");

//Für die Ausgabe von Daten kann die Funktion "alert"
//verwendet werden. Diese erzeugt ebenfalls einen
//kleinen modalen Dialog und zeigt die als Parameter
//übergebene Zeichenkette an. Besteht die auszugebende
//Zeichenkette wie hier aus statischem Text und Variablen, 
//dann können diese mittels des "+"-Operator zusammengesetzt
//werden.

alert("Ausgabe 1a: Hallo " + meinname);


//Dies klappt super, solange es sich um Zeichenketten
//handelt. Arbeitet man mit Zahlen, dann sind weitere
//Arbeitsschritte notwendig. Zuerst ein Beispiel, wie es
//nicht funktioniert:

var zahl1 = prompt("Geben Sie die erste Zahl ein: ");
var zahl2 = prompt("Geben Sie die zweite Zahl ein: ");

var summe = zahl1 + zahl2;

alert("Ergebnis: " + summe + " ?!?!!");


//Das Ergebnis entspricht nicht den Erwartungen.
//Begründung: Die Funktion "prompt" liefert die 
//Eingabe des Anwenders immer als Zeichenkette, auch
//dann, wenn der Anwender wie hier eine Zahl eingibt. 
//In Zeile 36 werden die beiden Eingaben "zahl1" und 
//"zahl2" verküpft. Allerdings hat der "+"-Operator zwei
//Bedeutungen. Ist einer der Operanden eine Zeichenkette,
//dann werden beide Operanden einfach aneinandergehängt.
//Das ist hier der Fall!
//Nur wenn beide Operanden numerische Werte (Zahlen) sind, 
//werden die Operanden mathematisch addiert. 
//Machen Sie sich an dieser Stelle noch einmal klar,
//warum das Ergebnis so aussieht, wie eben gesehen!


//Das Problem kann einfach gelöst werden. Die Eingaben
//des Anwenders müssen vor der weiteren Bearbeitung in
//eine Zahl gewandelt werden. Dazu steht beispielsweise
//die Funktion "parseInt" zur Verfügung. Wir können die
//Eingabe also einfach mit dieser Funktion umschließen:

var zahl1 = parseInt(prompt("Geben Sie noch einmal die erste Zahl ein: "));
var zahl2 = parseInt(prompt("Geben Sie noch einmal die zweite Zahl ein: "));

var summe = zahl1 + zahl2;

alert("Ergebnis: " + summe + " :)");


//Lesen Sie bitte auch die Information im Reiter "Aktuelle Aufgabe (2)"
//am unteren Fensterrand.

//Aufgabe erledigt? Dann einfach im Infobereich im Reiter 
//auf die "Aktuelle Aufgabe (2)" auf die Schaltfläche 
//"Kurs anzeigen" klicken und nächste Aufgabe auswählen.

alert("Ende");
`
        },

        {
            "id": "2",
            "pos": 3,
            "lfs": "L3",
            "title": "Weitere Alternativen zur Ausgabe von Daten (document.write/console.log)",
            "hint": "Keine Hinweise vorhanden",
            "material": [
                {
                    "title": "document.write-Funktion",
                    "url": "https://www.w3schools.com/jsref/met_doc_write.asp"
                },
                {
                    "title": "console.log-Funktion",
                    "url": "https://www.w3schools.com/jsref/met_console_log.asp"
                }
            ],
            "task": `Nicht immer ist es schön, für jede Ausgabe einen modalen Dialog zu öffnen. Sie lernen
            hier zwei Alternativen kennen. Öffnen Sie die Aufgabe und lesen Sie die Kommentare in der 
            Programmvorlage (Editor) aufmerksam. Starten Sie das Programm.`,
            "template": `// Einführung in die Thommy-IDE
// L3: Weitere Alternativen zur Ausgabe von Daten (document.write/console.log)

//Nicht immer ist es schön, für jede Ausgabe einen modalen
//Dialog zu öffnen. In der Regel soll die Ausgabe an 
//einer Stelle im bestehenden Fenster dargestellt werden.
//Dies kann mit den Funktionen "document.write" und
//"console.log" erreicht werden. Beide Funktionen erwarten
//als Parameter die Zeichenkette, die ausgegeben werden soll. 
//Die Ausgabe selbst erfolgt im Informationsbereich am 
//unteren Fensterrand, dort im Reiter "Konsole".

//Öffnen Sie den Reiter "Konsole", indem Sie auf den Reiter
//klicken. Starten Sie das Programm und beobachten Sie die
//Konsole.

//Auch hier können Sie das Programm alternativ im Debug-Modus 
//ausführen. Das Debug-Informationsfenster verfügt ebenfalls 
//über einen Bereich "Konsole", in welchem die Ausgaben zu
//finden sind.


var zahl1 = parseInt(prompt("Geben Sie noch einmal die erste Zahl ein: "));
var zahl2 = parseInt(prompt("Geben Sie noch einmal die zweite Zahl ein: "));

var summe = zahl1 + zahl2;


console.log("a. Ergebnis: " + summe);
document.write("b. Ergebnis: " + summe);
`
         },

         {
             "id": "3",
             "pos": 4,
             "lfs": "L4",
             "title": "Ein- / Ausgaben über automatisch generierte Textfelder",
             "hint": "Keine Hinweise vorhanden",
             "material": [
                 {
                     "title": "Zusammenfassung Ein- / Ausgaben",
                     "url": "https://www.w3schools.com/js/js_output.asp"
                 }
             ],
             "task": `Eleganter als die bisherigen Möglichkeiten zur Ein- und Ausgabe von Daten ist der Einsatz
             von Textfeldern. Die Thommy-IDE erkennt dabei die Notwendigkeit von Ein- und Ausgaben und erstellt 
             automatisch die entsprechenden Felder. Lesen Sie die Kommentare in der Programmvorlage (Editor) aufmerksam.
             <ol>
                <li style="margin-bottom:16px;">Stellen Sie sicher, dass das Ein-/Ausgabefenster geöffnet ist und sich im rechten Fensterbereich befindet
                   (siehe Kommentare im Programmcode). Versuchen Sie die Felder den entsprechenden Programmanweisungen zuzuordnen. </li>
                <li style="margin-bottom:16px;">Ändern Sie im Programmcode den Variablenname "Vorname" in "IhrVorname" und beobachten Sie das Ein-/Ausgabe-Fenster.</li>
                <li style="margin-bottom:16px;">Machen Sie sich den Unterschied zwischen Variablen mit der Endung ".value" und Variablen mit
                der Endung ".innerText" klar.</li>
                <li style="margin-bottom:16px;">Füllen Sie im Ein-/Ausgabefenster die Felder "IhrVorname" und "Nachname" aus und starten 
                Sie das Programm. Beobachten Sie das Ein-/Ausgabefenster.</li>
            </ol>`,
            "template": `// Einführung in die Thommy-IDE
// L4: Ein- / Ausgaben über automatisch generierte Textfelder

//Sind mehrere Eingaben durch den Anwender notwendig,
//so ist es nicht immer schön, hierfür eine Reihe von
//modalen Dialog zu öffnen. Komfortabler ist es, die
//geforderten Eingaben bequem vor dem Programmstart
//über geeignete Textfelder zu tätigen. Weitere Textfelder
//können dann der Ausgabe der berechneten Ergebnisse
//dienen.

//Die Thommy-IDE kann die Notwendigkeit solcher Felder
//erkennen und die Felder automatisch erstellen und
//anzeigen. Die Darstellung erfolgt im separaten
//"Ein-/Ausgabe"-Fenster. Standardmäßig ist dies nicht 
//sichtbar. Über den Menüeintrag "Ansicht->Ein-/Ausgabe-Fenster"
//kann die Sichtbarkeit des Fenster eingestellt werden.
//Durch Ziehen des Fenstertitels kann das Fenster bewegt 
//werden. Die Größe kann über das Ziehen der rechten unteren
//Ecke eingestellt werden.

//Öffnen Sie jetzt das Ein-/Ausgabefenster und bewegen Sie
//dies in die rechte Fensterhälfte, so, dass es den 
//Programmcode nicht verdeckt.

//Sie wundern sich eventuell, dass hier schon Felder zu sehen
//sind. Die Felder wurden von der Thommy-IDE automatisch
//durch Analyse des unten stehenden Programmcodes erstellt.

//Dabei gilt folgende Regel:
//Endet eine Variable mit ".value", ".innerText" oder ".innerHTML", 
//so wird für diese Variable ein Feld erstellt. Die 
//Beschriftung des Feldes entspricht dem Variablenname. 
//Variablen mit der Endung ".innerText" oder ".innerHTML"
//dienen ausschließlich der Ausgabe.

//Für die Experten: Bei dieser Art von Variablen handelt es 
//sich um ein Objekte. Für den Anfang ist es nicht wichtig, 
//dies zu verstehen.


//Eingabefeld für den Vorname erzeugen:
var vn = Vorname.value;

//Eingabefeld für den Nachname erzeugen:
var nn = Nachname.value;

//Ausgabefeld für den zusammengesetzten Namen erzeugen:
VollerName1.value = vn + " " + nn;

//Noch ein Ausgabefeld für den zusammengesetzten Namen erzeugen:
VollerName2.innerText = vn + " " + nn;
 `
          },

        {
            "id": "4",
            "pos": 5,
            "lfs": "L5",
            "title": "Beispiel: Berechnung der Summe zweier Zahlen mittels Ein-Ausgabe-Feldern",
            "hint": "Keine Hinweise vorhanden",
            "material": [],
            "task": `Das Beispiel berechnet ebenfalls die Summe zweier Zahlen. Die Ein- und Ausgabe der
            Daten erfolgt hierbei über automatisch generierte Felder.`,
            "template": `// Einführung in die Thommy-IDE
// L5: Beispiel: Berechnung der Summe zweier Zahlen mittels 
//     Ein-Ausgabe-Feldern

//Öffnen Sie das Ein-/Ausgabefenster und bewegen Sie
//dies in die rechte Fensterhälfte, so, dass es den 
//Programmcode nicht verdeckt. Füllen Sie die Felder
//Zahl1 und Zahl2 aus und starten Sie das Programm.
//Beobachten Sie das Ein-/Ausgabefenster.

var z1 = parseInt(Zahl1.value);
var z2 = parseInt(Zahl2.value);

var summe = z1 + z2;

Ergebnis.value = summe;
`
         },

         {
             "id": "5",
             "pos": 6,
             "lfs": "L6",
             "title": "Weitere Möglichkeit zur Erzeugung von Ein-Ausgabe-Feldern (document.getElementById)",
             "hint": "Keine Hinweise vorhanden",
             "material": [
                {
                    "title": "Zusammenfassung Ein- / Ausgaben",
                    "url": "https://www.w3schools.com/js/js_output.asp"
                },
                {
                    "title": "document.getElementById()",
                    "url": "https://www.w3schools.com/jsref/met_document_getelementbyid.asp"
                }
            ],
             "task": `In vielen Javascript-Programme finden sich Anweisungen wie "document.getElementById()" um
u. a. Ein- und Ausgabefelder anzusprechen. Der Vollständigkeit halber zeigt dieses Beispiel ein solches
Vorgehen. `,
"template": `// Einführung in die Thommy-IDE
// L6: Weitere Möglichkeit zur Erzeugung von 
//     Ein-Ausgabe-Feldern (document.getElementById)

//Öffnen Sie das Ein-/Ausgabefenster und bewegen Sie
//dies in die rechte Fensterhälfte, so, dass es den 
//Programmcode nicht verdeckt. Füllen Sie die Felder
//Zahl1 und Zahl2 aus und starten Sie das Programm.
//Beobachten Sie das Ein-/Ausgabefenster.

//Sie werden feststellen, dass es im Programmverhalten
//keinen Unterschied zur vorigen Aufgabe 5 gibt.
//Dennoch sieht der Programmcode deutlich komplizierter
//aus und möglicherweise muss im Unterricht auf den 
//Ausdruck
//
//  document.getElementById("Zahl1").value
//
//weiter eingegangen werden. 
//Liegt der Fokus auf der programmiertechnischen Umsetzung
//eines Algorithmus und nicht auf dem Erlernen der 
//Programmiersprache Javascript, dann ist aus didaktischen
//Gründen sicherlich die Vorgehensweise aus Aufgabe 5 
//sinnvoller.

var z1 = parseInt( document.getElementById("Zahl1").value );
var z2 = parseInt( document.getElementById("Zahl2").value );

var summe = z1 + z2;

document.getElementById("Ergebnis").value = summe;
 `
          },

          {
            "id": "6",
            "pos": 7,
            "lfs": "L7",
            "title": "Schaltflächen für den Aufruf von Funktionen (Buttons)",
            "hint": "Keine Hinweise vorhanden",
            "material": [
               {
                   "title": "Zusammenfassung Ein- / Ausgaben",
                   "url": "https://www.w3schools.com/js/js_output.asp"
               },
               {
                   "title": "document.getElementById()",
                   "url": "https://www.w3schools.com/jsref/met_document_getelementbyid.asp"
               }
           ],
            "task": `Dieser Abschnitt erläutert das Erstellen von Schaltflächen in Form eines Buttons. Soll bestimmte Funktionalität erst nach Klick auf eine Schaltfläche ausgeführt werden, dann bieten sich Funktionen in 
            Kombination mit Buttons an. Ein Klick auf einen Button ruft die zugeordnete Funktion auf.`,
"template": `// Einführung in die Thommy-IDE
// L7: Schaltflächen für den Aufruf von Funktionen (Buttons)

// Öffnen Sie im ersten Schritt das Ein-
// und Ausgabefenster (STRG+E). Passen Sie
// Position und Größe an.
// Versuchen Sie die Verbindung zwischen dem 
// Programmcode und der Darstellung des 
// Ein-/Ausgabefenster zu verstehen.
// Lesen Sie dazu folgende Ausführungen.


// Initialisierung der Eingabefelder
Zahl1.value = "";
Zahl2.value = "";


// Im Folgenden werden drei Funktionen erstellt. Die 
// Funktion "add" ermittelt die Werte der beiden
// Eingabefelder und gibt die Summe der beiden
// Werte in das Ausgabefeld "Ergebnis". Die Funktion
// "multiply" multipliziert die beiden Zahlen. Alle Felder
// können mittels der Funktion "empty" wieder geleert 
// werden.
//
// Beim Ermitteln der Eingabe muss diese in eine
// Zahl gewandelt werden. Sie haben bereits die
// Funktion parseInt(...) kennengelernt, die eine
// solche Umwandlung ermöglicht. Wir sprechen dabei 
// auch von einer explizite Typenkonvertierung.
// Hier wird noch eine weitere Variante vorgestellt. 
// Multipliziert man einen Text mit dem Faktor 1, so 
// versucht das System automatisch (explizt) den Text 
// in eine Zahl zu konvertieren. Ist dies erfolgreich, 
// so werden die beiden Faktoren multipliziert, das 
// Ergebnis ist eine Zahl. Man spricht hier von einer 
// impliziten Typenkonvertierung.

function add() {
    var z1 = 1 * Zahl1.value;
    var z2 = 1 * Zahl2.value;

    Ergebnis.value = z1 + z2;
}

function multiply() {
    var z1 = 1 * Zahl1.value;
    var z2 = 1 * Zahl2.value;

    Ergebnis.value = z1 * z2;
}

function empty() {
    Zahl1.value = "";
    Zahl2.value = "";
    Ergebnis.value = "";
}


// Im Folgenden werden die Schaltflächen (Buttons)
// erstellt und den einzelnen Funktionen zugeordnet.
// Solche Schaltflächen werden immer an dem "Anhängsel"
// (Attribut) "onclick" erkannt. Der Wert vor diesem
// Attribut gibt die Beschriftung des Buttons an. Diesem
// Ausdruck kann nun eine Funtion zugeordnet werden, die
// bei Klick auf den Button aufgerufen wird. Geben Sie
// dazu einfach hinter dem Zuweisungsoperator 
// (Gleichheitszeichen) den Namen der Funktion an. 
// Achtung: Hinter dem Funktionsnamen dürfen keine
// Klammern hinzufügt werden.
// 
// Muster:
//   Beschriftung.onclick = Funktionsname;

Addieren.onclick = add;
Multiplizieren.onclick = multiply;
FelderLeeren.onclick = empty;


// Starten Sie das Programm über den Menüeintrag
// Programm->Ausführen oder mit der Tastenkombinaiton
// STRG+F11. Die Schaltflächen sind nun aktiv. 
// Testen Sie!



// Hinweis:
// Die Übergabe von Parametern an Funktionen ist etwas
// komplizierter. Möchte man beispielsweise einer
// Funktion "add" zwei Paramter übergeben, so muss 
// dies in folgender Form erfolgen:
// 
//   Addieren.onclick = function() { add(1, 2) };
//                                   ^^^^^^^^^
//
// Der eigentlichen Funktionsaufruf (^) muss also zusätzlich
// in eine anonyme Funktion gepackt werden. 

console.log("ENDE");
`
         },

          {
              "id": "7",
              "pos": 8,
              "lfs": "L8",
              "title": "Weitere Funktionen der Thommy-IDE",
              "hint": "Keine Hinweise vorhanden",
              "material": [],
              "task": `Diese Aufgabe stellt Ihnen weitere Funktionen der Thommy-IDE vor.
              <p>
              <ol>
                <li style="margin-bottom:16px;">Sie finden bereits eine Menge Programmcode vor. Dieser ist wenig gut lesbar, was vor allem
                an der Platzierung und am Einrücken der einzelnen Anweisungen liegt. Die Thommy-IDE verfügt über 
                einen Beautifier, welcher den Code automatisch formatieren kann. Drücken Sie dazu die 
                Tastenkombination STRG-B oder wählen Sie den Menüeintrag "Programm->Beautify". Der Code sollte
                anschließend korrekt formatiert sein.</li>
                <li style="margin-bottom:16px;">Führen Sie das Programm aus. Sie werden feststellen, dass nicht viel passiert. Dies liegt daran,
                dass das Programm nicht fehlerfrei ist. In Zeile 11 wird eine Funktion eines Objektes aufgerufen,
                dass es nicht gibt (consoleABC.prompt). Fehler bei der Programmausführung werden im Informationsbereich
                im unteren Fensterbereich im Reiter "Fehler" angezeigt. Endet die Überschrift mit "!!!", so ist dies ein
                Zeichen dafür, dass ein Fehler aufgetreten ist. Klicken Sie auf den Reiter "Fehler", um die Fehlermeldung
                einsehen zu können. Korrigieren Sie den Fehler, indem Sie die Zeile 11 einfach komplett entfernen!
                Öffnen Sie das Ein-/Ausgabe-Fenster und starte Sie das Programm erneut. Das Programm hat keinen eigentlichen Sinn!
                </li>
                <li style="margin-bottom:16px;">Klicken Sie auf einen beliebigen Bereich innerhalb des Struktogramms. Der zugehörige Programmcode wird 
                im Programmeditor markiert. Ist der Programmausschnitt im Editor nicht sichtbar, dann wird automatisch
                an die korrekte Stelle gescrollt. Dieses Verhalten lässt sich über den Menüeintrag "Ansicht->Autom. Scrollen"
                deaktivieren.<br>
                Vor allem bei der Analyse von Verzweigungen kann dies das Verständnis
                der SchülerInnen erhöhen. Man kann im Struktogramm die gesamte Verzweigung oder die einzelnen Zweige markieren. Für
                das Markieren der einzelnen Zweige einer Verzweigung können Sie auf das zugehörige "j" oder "n" 
                klicken.
                </li>
                <li style="margin-bottom:16px;">Im Unterricht ist es möglicherweise sinnvoll, nur den Programmcode oder nur das 
                Struktogramm anzeigen zu lassen. Sie können die beiden Komponenten über das Menü "Ansicht" ein- und 
                ausblenden. Testen Sie! Der vertikale Balken zwischen den beiden Bereichen dient zur Veränderung der
                Größe der beiden Bereiche. Ziehen Sie den Balken nach links bzw. rechts.</li>
                <li style="margin-bottom:16px;">Die Ergebnissicherung kann in Form eines PDF-Exports erfolgen. Klicken Sie dazu auf den
                Menüeintrag "Datei->PDF erzeugen". Nach einer kurzen Zeit steht eine PDF-Datei zur Verfügung, 
                welche den Programmcode und das Struktogramm beinhaltet. Aktuell ist das Sokument auf eine Seite beschränkt.
                Möchte man nur eine der beiden Komponenten
                in der PDF-Datei abbilden, dann kann der nicht gewünschte Bereich über das Menü "Ansicht" ausgeblendet
                werden, bevor der PDF-Export efolgt. Erstellen Sie einen PDF-Export.
                </li>
                <li style="margin-bottom:16px;">
                    Über den Menüeintrag "Datei->Speichern" kann der aktuelle Programmcode gespeichert werden. Beim Neustart von
                    Thommy wird der zuletzt gespeicherte Programmcode inital geladen. Achtung: Die Speicherung der Daten erfolgt im 
                    Browser-Profil des Benutzers. Damit ist dieser nur wieder erreichbar, wenn der Benutzer sich mit dem gleichen
                    Browser und dem gleichen Profil anmeldet. Vor der Ausführung des Programmcodes erfolgt eine automatische Sicherung.
                    <p>
                    Leeren Sie den Editor (Programm->Editor leeren) und tippen Sie Ihren Namen in das Editorfenster. Speichern 
                    Sie (Datei->Speichern). Der Speichervorgang wird im Informationsbereich am unteren Ende des Fensters im Reiter
                    "Info" protokolliert. Starten Sie Thommy neu (Datei->Thommy neu starten).
                    </p>
                </li>
                <li style="margin-bottom:16px;">
                    Aktuelle Informationen und Informationen zur Historie finden Sie im Menü "Hilfe". Wählen Sie dort 
                    den Menüeintrag "Info" an oder drücken Sie einfach die Tastenkombination STRG-I.
                </li>
              </ol>
            </p>
              `,
 "template": `// Einführung in die Thommy-IDE
 // L8: Weitere Funktionen der Thommy-IDE
 
 //Lesen Sie Aufgabenstellung im Informationsbereich im
 //Reiter "Aktuelle Aufgabe (8)"
 
 //Folgender Programmcode hat keinerlei Sinn. Er dient
 //lediglich dazu, einige Funktionen und Möglichkeiten
 //der Thommy-IDE zu demonstrieren.
 
 consoleABC.log("Hallo");
 
 var startAsStr = "";var endeAsStr = "";
 if (Startwert.value == 0 || Endewert.value == 0) {
 startAsStr = prompt("Startwert: ");    Startwert.value = startAsStr;
 endeAsStr = prompt("Endwert: ");    Endewert.value = endeAsStr;
 } else {
 startAsStr = Startwert.value;    endeAsStr = Endewert.value;
 }
 
 var start = parseInt(startAsStr);
 var ende = parseInt(endeAsStr);
 
 let i = start;
 while (i < ende) {
 console.log(i);
 if (i % 2 === 0) {
 console.log('#');
 } else {
 console.log('*');
 }
 i++;
 }
 
 i = start;
 do {
 console.log(i);
 if (i % 2 === 0) {
 console.log('#');
 } else {
 if (i < (ende - start) / 2) {
 console.log('*#*');
 } else {
 console.log('*');
 }
 }
 i = i + 1;
 } while (i < ende);
 
 const text = 'Lorem ipsum dolor sit amet';
 
 Bemerkung1.value = text;
 
 Bemerkung2.innerText = text;
 for (var x = 0; x < 3; x++) {
 Bemerkung2.innerText = Bemerkung2.innerText + "\\n" + text;
 }
 
 document.getElementById("Motto").value = "Alles wird gut";
`
           }
    ]
}